SystemOrganization addCategory: #'LRSTM-Tests'!

OstObject subclass: #LRSTMHello
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMHello class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/29/2011 01:12'!
example
	|  p1 p2 hello |
	hello := self new.
	
	"Since this main thread is not running inside the OPSTMDomain, which would be easy, too,
	 but is not happening here, we need to manually move the object into the domain."
	
	hello a: 'main'; b: 'main'.
	
	p1 := [
		1 halt.
		[	hello a: 'p1'.
			Processor yield.
			hello b: 'p1'.] atomic
	] fork.

	p2 := [
		[	| b |
			b := hello b.
			Processor yield.
			hello b: 'p2'.] atomic
	] fork.! !

!LRSTMHello methodsFor: 'accessing' stamp: 'StefanMarr 11/29/2011 01:11'!
a
	^ a asString! !

!LRSTMHello methodsFor: 'accessing' stamp: 'StefanMarr 11/29/2011 01:12'!
a: obj
	a := obj asString! !

!LRSTMHello methodsFor: 'accessing' stamp: 'StefanMarr 12/5/2011 16:54'!
b
	^ b asString! !

!LRSTMHello methodsFor: 'accessing' stamp: 'StefanMarr 12/5/2011 16:54'!
b: obj
	b := obj asString! !

!LRSTMHello methodsFor: 'initialization' stamp: 'StefanMarr 12/5/2011 11:34'!
initialize
	super initialize.
	a := #a.
	b := #b.! !

!LRSTMHello methodsFor: 'nbody - stack test' stamp: 'StefanMarr 8/5/2012 23:11'!
nbodyInitialize
	b := OrderedCollection new add: self; yourself.
	
	b first offsetMomentum: (b
				inject: 0
				into: [:m :each | each offsetMomentum: m])! !

!LRSTMHello methodsFor: 'nbody - stack test' stamp: 'StefanMarr 8/5/2012 00:33'!
offsetMomentum: obj
	^ obj! !

LRSTMHello subclass: #LRSTMHello2
	instanceVariableNames: 'c d'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMHello2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
c
	^ c! !

!LRSTMHello2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:29'!
c: v
	c := v! !

!LRSTMHello2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
d
	^ d! !

!LRSTMHello2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:29'!
d: v
	d := v! !

!LRSTMHello2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:33'!
initialize
	super initialize.
	c := #c.
	d := #d.! !

LRSTMHello2 subclass: #LRSTMHello3
	instanceVariableNames: 'e f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
a
	^ a! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
a: v
	a := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
b
	^ b! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
b: v
	b := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
c
	^ c! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
c: v
	c := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
d
	^ d! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
d: v
	d := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
e
	^ e! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
e: v
	e := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:36'!
f
	^ f! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 12:28'!
f: v
	f := v! !

!LRSTMHello3 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 12/5/2011 11:33'!
initialize
	super initialize.
	e := #e.
	f := #f.! !

OstObject subclass: #LRSTMTestBag
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMTestBag methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 10:37'!
add: elem
	contents at: elem put: 0.
	^ elem! !

!LRSTMTestBag methodsFor: 'accessing' stamp: 'StefanMarr 8/2/2012 10:24'!
contents
	^ contents! !

!LRSTMTestBag methodsFor: 'test helper' stamp: 'StefanMarr 8/2/2012 10:22'!
grow
	contents grow! !

!LRSTMTestBag methodsFor: 'initialization' stamp: 'StefanMarr 8/2/2012 16:16'!
initialize
	super initialize.
	contents := LRSTMTestDict new.! !

OstObject subclass: #LRSTMTestDict
	instanceVariableNames: 'array tally'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:37'!
array
	^ array! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:22'!
at: key put: anObject 
	"Set the value at key to be anObject.  If key is not found, create a
	new entry for key and set is value to anObject. Answer anObject."

	| index assoc |
	index := self findElementOrNil: key.
	assoc := array at: index.
	assoc
		ifNil: [self atNewIndex: index put: (Association key: key value: anObject)]
		ifNotNil: [assoc value: anObject].
	^ anObject! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:23'!
atNewIndex: index put: anObject
	array at: index put: anObject.
	tally := tally + 1.! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:25'!
findElementOrNil: anObject
	(array at: 1) == anObject 
		ifTrue:  [ ^ 1 ]
		ifFalse: [ ^ 1 ]! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/4/2012 15:30'!
grow
	"Grow the elements array and reinsert the old elements"

	| oldElements |
	oldElements := array.
	array := Array new: oldElements size * 2.
	tally := 0.
	
	oldElements
		do:
			[ :each | 
			each == nil
				ifFalse: [ self noCheckAdd: each ] ]! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:18'!
initialize
	array := Array new: 1.
	tally := 0.! !

!LRSTMTestDict methodsFor: 'as yet unclassified' stamp: 'StefanMarr 8/2/2012 16:31'!
noCheckAdd: anObject
	"Must be defined separately for Dictionary because (self findElementOrNil:) expects a key, not an association.  9/7/96 tk"

	array at: (self findElementOrNil: anObject key) put: anObject.
	tally := tally + 1! !

OstTestCase subclass: #LRSTMOmniTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMOmniTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/13/2013 17:31'!
expectedFailures
	(Smalltalk hasClassNamed: #OstDomain) ifFalse: [
		^ #(testOmniDomain)].
	
	^ super expectedFailures! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:11'!
testAsString
	| result |
	
	result := [ #ab asString ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:20'!
testAsStringCompletelyResolved
	| result |
	
	result := [ | str |
			  str := ByteString new: 2.
			  str replaceFrom: 1 to: 2 with: #ab startingAt: 1. ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:25'!
testAsStringLessLessLessPartiallyResolved
	| result |
	
	result := [ | str sym |
			sym := #ab.
			  str := sym species new: sym size.
			  str replaceFrom: 1 to: str size with: sym startingAt: 1. ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:24'!
testAsStringLessLessPartiallyResolved
	| result |
	
	result := [ | str |
			  str := #ab species new: #ab size.
			  str replaceFrom: 1 to: str size with: #ab startingAt: 1. ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:19'!
testAsStringLessPartiallyResolved
	| result |
	
	result := [ | str |
			  str := #ab species new: 2.
			  str replaceFrom: 1 to: str size with: #ab startingAt: 1. ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:19'!
testAsStringPartiallyResolved
	| result |
	
	result := [ | str |
			  str := ByteString new: 2.
			  str replaceFrom: 1 to: str size with: #ab startingAt: 1. ] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 21:58'!
testAtomicReplaceFrom
	| result |
	
	result := [ |  str |
			  str := ByteString new: 10.
			  str atomicReplaceFrom: 1 to: 2 with: 'abcdef' startingAt: 1] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 17:11'!
testBagGrow
	| d | 
	[ d := LRSTMTestBag new.
	 d add: #foo.
	 d grow.] atomic.
	
	self assert: 2 equals: d contents array size.! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 16:10'!
testBagSimple
	| bag |
	bag := [Bag new: 1] atomic.
	
	[bag add: #a.
	 bag add: #b.
	 bag add: #c.
	 bag add: #d.
	 bag add: #e.] atomic.
	
	self assert: 5 equals: bag size.
	self assert: (bag includes: #a).
	self assert: (bag includes: #e).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 01:09'!
testDictGrow
	| d | 
	[ d := Dictionary new: 1.
	 d grow.] atomic.
	
	self assert: 11 equals: d array size.! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/5/2012 00:38'!
testNBodyProblem
	| result |
	result := [LRSTMHello new nbodyInitialize] atomic.! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 1/13/2013 17:18'!
testOmniDomain
	| domain ostDomainCls lrstmCls |
	ostDomainCls := Smalltalk at: #OstDomain.
	lrstmCls     := Smalltalk at: #LRSTMDomain.
	
	[ domain := ostDomainCls currentDomain. ] atomic.

	self deny: domain isNil.
	self assert: (domain isKindOf: lrstmCls)! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/5/2012 11:14'!
testPrimAtDirectTest
	| return o |
	return := [
		| col |
		o := OstObject new.
		col := OrderedCollection new.
		col add: o.
		col first ] atomic.
	
	self assert: o equals: return.
	self assert: (o isKindOf: OstObject).! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/5/2012 11:13'!
testPrimAtSimplifiedNBody
	| result |
	result := [LRSTMHello new nbodyInitialize] atomic.! !

!LRSTMOmniTest methodsFor: 'tests' stamp: 'StefanMarr 8/1/2012 22:06'!
testReplaceFrom
	| result |
	
	result := [ |  str |
			  str := ByteString new: 10.
			  str replaceFrom: 1 to: 2 with: 'abcdef' startingAt: 1] atomic.
	
	self assert: ByteString equals: result class.
	self assert: $a equals: (result at: 1).
	self assert: $b equals: (result at: 2).! !

OstTestCase subclass: #LRSTMTest
	instanceVariableNames: 'value array'
	classVariableNames: 'Value'
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

LRSTMTest subclass: #LRSTMAbortTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'StefanMarr 11/30/2011 20:12'!
testAbortAccessor
	self assert: [ self value: true; abort: self value ] atomic.
	self assert: self value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:11'!
testAbortInstance
	self assert: [ value := true. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortLiteral
	self assert: [ Value := true. self abort: Value ] atomic.
	self assert: Value isNil! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortTemp
	| temp |
	self assert: [ temp := true. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-abort' stamp: 'lr 5/14/2007 09:12'!
testAbortVariable
	self assert: [ array at: 1 put: true. self abort: (array at: 1) ] atomic.
	self assert: (array at: 1) isNil! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 6/8/2007 16:50'!
testCheckAccessor
	self assert: [ self value: true; checkpoint; abort: self value ] atomic.
	self assert: self value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckInstance
	self assert: [ value := true. self checkpoint. self abort: value ] atomic.
	self assert: value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckLiteral
	self assert: [ Value := true. self checkpoint. self abort: Value ] atomic.
	self assert: Value! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckTemp
	| temp |
	self assert: [ temp := true. self checkpoint. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-check' stamp: 'lr 5/14/2007 09:13'!
testCheckVariable
	self assert: [ array at: 1 put: true. self checkpoint. self abort: (array at: 1) ] atomic.
	self assert: (array at: 1)! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'StefanMarr 4/15/2012 23:09'!
testErrorAccessor
	self 
		should: [ [ self value: true. self assert: self value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorInstance
	self 
		should: [ [ value := true. self assert: value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorLiteral
	self 
		should: [ [ Value := true. self assert: Value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: Value isNil! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:43'!
testErrorTemp
	| temp |
	self 
		should: [ [ temp := true. self assert: temp. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: temp! !

!LRSTMAbortTest methodsFor: 'testing-error' stamp: 'lr 5/14/2007 08:39'!
testErrorVariable
	self 
		should: [ [ array at: 1 put: true. self assert: (array at: 1). 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: (array at: 1) isNil! !

LRSTMTest subclass: #LRSTMBasicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessor
	self assert: [ self value: true. self value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessorRead
	self value: true.
	self assert: [ self value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:18'!
testAccessorWrite
	[ self value: true ] atomic.
	self assert: self value! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 14:56'!
testBasicContext
	self assert: [ thisContext home ] atomic == thisContext! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 11:18'!
testBasicSelf
	self assert: [ self ] atomic == self! !

!LRSTMBasicTest methodsFor: 'testing-basic' stamp: 'lr 5/9/2007 11:18'!
testBasicSuper
	self assert: [ super ] atomic == self! !

!LRSTMBasicTest methodsFor: 'testing-inheritance' stamp: 'StefanMarr 1/13/2013 17:45'!
testFieldReads
	| h |
	h := LRSTMHello3 new.
	self adopt: h.
	
	self assert: #a equals: [h a] atomic.
	self assert: #b equals: [h b] atomic.
	self assert: #c equals: [h c] atomic.
	self assert: #d equals: [h d] atomic.
	self assert: #e equals: [h e] atomic.
	self assert: #f equals: [h f] atomic.! !

!LRSTMBasicTest methodsFor: 'testing-inheritance' stamp: 'StefanMarr 1/13/2013 17:45'!
testFieldReadsMixedInherited
	| h |
	h := LRSTMHello2 new.
	self adopt: h.
	
	self assert: #a equals: [h a] atomic.
	self assert: #b equals: [h b] atomic.
	self assert: #c equals: [h c] atomic.
	self assert: #d equals: [h d] atomic.! !

!LRSTMBasicTest methodsFor: 'testing-inheritance' stamp: 'StefanMarr 1/13/2013 17:45'!
testFieldWrite
	| h |
	h := LRSTMHello3 new.
	self adopt: h.
	
	[h a: #A] atomic.
	self assert: #A equals: [h a] atomic.
	
	[h b: #B] atomic.
	self assert: #B equals: [h b] atomic.
	
	[h c: #C] atomic.
	self assert: #C equals: [h c] atomic.
	
	[h d: #D] atomic.
	self assert: #D equals: [h d] atomic.
	
	[h e: #E] atomic.
	self assert: #E equals: [h e] atomic.
	
	[h f: #F] atomic.
	self assert: #F equals: [h f] atomic.! !

!LRSTMBasicTest methodsFor: 'testing-inheritance' stamp: 'StefanMarr 1/13/2013 17:48'!
testFieldWriteMixedInherited
	| h |
	h := LRSTMHello2 new.
	self adopt: h.
	
	[h a: #A] atomic.
	self assert: #A equals: [h a] atomic.
	
	[h b: #B] atomic.
	self assert: #B equals: [h b] atomic.
	
	[h c: #C] atomic.
	self assert: #C equals: [h c] atomic.
	
	[h d: #D] atomic.
	self assert: #D equals: [h d] atomic.! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobal
	self assert: [ GlobalValue := true. GlobalValue ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobalRead
	GlobalValue := true.
	self assert: [ GlobalValue ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testGlobalWrite
	[ GlobalValue := true ] atomic.
	self assert: GlobalValue! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedAndOr
	self assert: [ true and: [ true ] ] atomic.
	self deny: [ false and: [ true ] ] atomic.
	self deny: [ true and: [ false ] ] atomic.
	self deny: [ false and: [ false ] ] atomic.

	self assert: [ true or: [ true ] ] atomic.
	self assert: [ false or: [ true ] ] atomic.
	self assert: [ true or: [ false ] ] atomic.
	self deny: [ false and: [ false ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/11/2007 15:07'!
testInlinedArray
	self assert: [ { } ] atomic = #( ).
	self assert: [ { 1 } ] atomic = #( 1 ).
	self assert: [ { 1. 2 } ] atomic = #( 1 2 ).
	self assert: [ { 1. 2. 3 } ] atomic = #( 1 2 3 ).
	self assert: [ { 1. 2. 3. 4 } ] atomic = #( 1 2 3 4 ).
	self assert: [ { 1. 2. 3. 4. 5 } ] atomic = #( 1 2 3 4 5 ).
	self assert: [ { 1. 2. 3. 4. 5. 6 } ] atomic = #( 1 2 3 4 5 6 )! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/11/2007 15:23'!
testInlinedArrayNested
	self assert: [ { { } } ] atomic = #( ( ) ).
	self assert: [ { { 1 } } ] atomic = #( ( 1 ) ).
	self assert: [ { { 1. 2 } } ] atomic = #( ( 1 2 ) ).
	self assert: [ { { 1. 2 }. { 3 } } ] atomic = #( ( 1 2 ) ( 3 ) ).
	self assert: [ { { 1. 2 }. { 3. 4 } } ] atomic = #( ( 1 2 ) ( 3 4 ) )! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedIfNil
	self assert: [ nil ifNil: [ true ] ] atomic.
	self assert: [ 1 ifNotNil: [ true ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 14:58'!
testInlinedIfTrue
	self assert: [ true ifTrue: [ true ] ] atomic.
	self assert: [ false ifFalse: [ true ] ] atomic.
	self assert: [ true ifTrue: [ true ] ifFalse: [ false ] ] atomic.
	self assert: [ false ifFalse: [ true ] ifTrue: [ false ] ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 11:42'!
testInlinedToDo
	| x |
	x := 0.
	[ 1 to: 10 do: [ :i | x := x + i ] ] atomic.
	self assert: x = 55.
	
	x := 0.
	[ 1 to: 10 by: 2 do: [ :i | x := x + i ] ] atomic.
	self assert: x = 25 ! !

!LRSTMBasicTest methodsFor: 'testing-inlined' stamp: 'lr 5/9/2007 15:14'!
testInlinedWhile
	| i x | 
	i := 1. x := 0.
	[ [ x := x + i. i := i + 1. i <= 10 ] whileTrue ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ i <= 10 ] whileTrue: [ x := x + i. i := i + 1 ] ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ x := x + i. i := i + 1. i > 10 ] whileFalse ] atomic.
	self assert: x = 55.
	
	i := 1. x := 0.
	[ [ i > 10 ] whileFalse: [ x := x + i. i := i + 1 ] ] atomic.
	self assert: x = 55! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstance
	self assert: [ value := true. value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstanceRead
	value := true.
	self assert: [ value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testInstanceWrite
	[ value := true ] atomic.
	self assert: value! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteral
	self assert: [ Value := true. Value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteralRead
	Value := true.
	self assert: [ Value ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testLiteralWrite
	[ Value := true ] atomic.
	self assert: Value! !

!LRSTMBasicTest methodsFor: 'testing' stamp: 'lr 5/10/2007 09:48'!
testLoop
	"This code showed some bug in the exception handling."
	
 	| current |
	[ current := SortedCollection.
	[ current == nil ] whileFalse: [
		current == Object ifTrue: [ ^ self ].
		current := current superclass ] ]
			value.
	self assert: current == Object! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendBinary
	self assert: [ 1 + 2 ] atomic = 3! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendKeyword
	self assert: [ 2 raisedTo: 3 ] atomic = 8! !

!LRSTMBasicTest methodsFor: 'testing-sends' stamp: 'lr 5/9/2007 11:24'!
testSendUnary
	self assert: [ 1 negated ] atomic = -1! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTemp
	| temp |
	self assert: [ temp := true. temp ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTempRead
	| temp |
	temp := true.
	self assert: [ temp ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testTempWrite
	| temp |
	[ temp := true ] atomic.
	self assert: temp! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariable
	self assert: [ array at: 1 put: true; at: 1 ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariableRead
	array at: 1 put: true.
	self assert: [ array at: 1 ] atomic! !

!LRSTMBasicTest methodsFor: 'testing-kinds' stamp: 'lr 5/9/2007 11:19'!
testVariableWrite
	[ array at: 1 put: true ] atomic.
	self assert: (array at: 1)! !

LRSTMTest subclass: #LRSTMCUTransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCUTransactionTest commentStamp: 'StefanMarr 11/28/2011 22:08' prior: 0!
This test suite is actually originating from the Cutie-Helvetia-Trans implementation.
It is ported back to the STM implementation Lukas Renggli implemented originally with Geppetto on Squeak 3.9!

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:25'!
conflict
	self transaction 
		addChange: (LRSTMCustomChange 
			onApply: [ value := true ]
			onConflictTest: [ true ])! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:21'!
sideeffect
	self transaction 
		addChange: (LRSTMCustomChange
			onApply: [ value := true ])! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortAccessor
	self assert: [ self value: true; abort: self value ] atomic.
	self assert: self value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortInstance
	self assert: [ value := true. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-abort' stamp: 'lr 2/23/2009 16:31'!
testAbortTemp
	| temp |
	self assert: [ temp := true. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessor
	self assert: [ self value: true. self value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorRead
	self value: true.
	self assert: [ self value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testAccessorWrite
	[ self value: true ] atomic.
	self assert: self value! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicContext
	self assert: [ thisContext home ] atomic == thisContext! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSelf
	self assert: [ self ] atomic == self! !

!LRSTMCUTransactionTest methodsFor: 'testing' stamp: 'lr 2/23/2009 16:31'!
testBasicSuper
	self assert: [ super ] atomic == self! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckAccessor
	self assert: [ self value: true; checkpoint; abort: self value ] atomic.
	self assert: self value! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckInstance
	self assert: [ value := true. self checkpoint. self abort: value ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'testing-check' stamp: 'lr 2/23/2009 16:31'!
testCheckTemp
	| temp |
	self assert: [ temp := true. self checkpoint. self abort: temp ] atomic.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'StefanMarr 11/28/2011 22:25'!
testConflict
	self 
		should: [ [ self conflict ] atomic ]
		raise: LRSTMConflict.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorAccessor
	self 
		should: [ [ self value: true. self assert: self value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorInstance
	self 
		should: [ [ value := true. self assert: value. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: value isNil! !

!LRSTMCUTransactionTest methodsFor: 'testing-error' stamp: 'lr 2/23/2009 16:31'!
testErrorTemp
	| temp |
	self 
		should: [ [ temp := true. self assert: temp. 1 / 0 ] atomic ]
		raise: ZeroDivide.
	self assert: temp! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstance
	self assert: [ value := true. value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceRead
	value := true.
	self assert: [ value ] atomic! !

!LRSTMCUTransactionTest methodsFor: 'testing-kinds' stamp: 'lr 2/23/2009 16:31'!
testInstanceWrite
	[ value := true ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'testing-custom' stamp: 'lr 2/23/2009 16:31'!
testSideeffect
	[ self sideeffect ] atomic.
	self assert: value! !

!LRSTMCUTransactionTest methodsFor: 'private' stamp: 'StefanMarr 5/1/2012 22:56'!
workingCopy
	"Answer a working copy to be used within the context of the current transaction."
	
	| transaction |
	transaction := self transaction
		ifNil: [ ^ self ].
	^ (transaction changeFor: self) 
		working! !

LRSTMTest subclass: #LRSTMCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 7/21/2012 23:58'!
testArrayLong
	| arr |
	[ arr := OstArray new: 10 withAll: 1. ] atomic.
	
	[ 3 to: 10 do: [ :each |
		arr at: each put: (arr at: each - 1) + (arr at: each - 2) ] ]
			atomic.
	3 to: 10 do: [ :each |
		self assert: (arr at: each) - (arr at: each - 1) = (arr at: each - 2) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 7/21/2012 23:58'!
testArrayShort
	| arr |
	[ arr := OstArray new: 10 withAll: 1.] atomic.
	
	3 to: 10 do: [ :each |
		[ arr at: each put: (arr at: each - 1) + (arr at: each - 2) ]
			atomic ].
	3 to: 10 do: [ :each |
		self assert: (arr at: each) - (arr at: each - 1) = (arr at: each - 2) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 7/31/2012 23:04'!
testBagLong
	| bag |
	[ bag := Bag new. ] atomic.
	
	[ 1 to: 10 do: [ :each |
		bag add: each; add: each ] ]
			atomic.
	self assert: bag size = 20.
	1 to: 10 do: [ :each | 
		self assert: 2 equals: (bag occurrencesOf: each)]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 7/29/2012 19:55'!
testBagShort
	| bag |
	[ bag := Bag new. ] atomic.
	
	1 to: 10 do: [ :each |
		[ bag add: each; add: each ]
			atomic ].
	
	self assert: 20 equals: bag size.
	
	1 to: 10 do: [ :each | 
		self assert: 2 equals: (bag occurrencesOf: each)]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 1/13/2013 17:48'!
testDictionaryGrow
	| dict |
	dict := Dictionary new.
	self adopt: dict.
	[ dict grow ] atomic.! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 1/13/2013 17:48'!
testDictionaryLong
	| dict |
	dict := Dictionary new.
	self adopt: dict.
	
	[ 1 to: 10 do: [ :each | 
		dict at: each put: each ] ]
			atomic.
	self assert: dict size = 10.
	1 to: 10 do: [ :each | 
		self assert: (dict at: each) = each ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 1/13/2013 17:48'!
testDictionaryShort
	| dict |
	dict := Dictionary new.
	self adopt: dict.
	
	1 to: 10 do: [ :each | 
		[ dict at: each put: each ]
			atomic ].
	self assert: dict size = 10.
	1 to: 10 do: [ :each | 
		self assert: (dict at: each) = each ]! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'StefanMarr 1/13/2013 17:48'!
testReadStream
	| stream |
	stream := (1 to: 10) asArray readStream.
	self adopt: stream.
	
	[ 1 to: 10 do: [ :each | self assert: each equals: stream next ] ]
		atomic! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 1/13/2013 17:48'!
testSetLong
	| set |
	set := Set new.
	self adopt: set.
	
	[ 1 to: 10 do: [ :each | 
		set add: each ] ] 
			atomic.
	self assert: set size = 10.
	1 to: 10 do: [ :each | 
		self assert: (set includes: each) ]! !

!LRSTMCollectionTest methodsFor: 'testing' stamp: 'StefanMarr 1/13/2013 17:49'!
testSetShort
	| set |
	set := Set new.
	self adopt: set.
	
	1 to: 10 do: [ :each |
		[ set add: each ]
			atomic ].
	self assert: set size = 10.
	1 to: 10 do: [ :each | 
		self assert: (set includes: each) ]! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'StefanMarr 7/29/2012 19:55'!
testStreamContents
	[array := Array streamContents: [ :stream |
		1 to: 10 do: [ :each | 
			stream nextPut: each ] ].
	] atomic.
	self assert: (1 to: 10) asArray equals: array! !

!LRSTMCollectionTest methodsFor: 'testing-streams' stamp: 'StefanMarr 1/13/2013 17:49'!
testWriteStream
	| stream |
	stream := (Array new: 10) writeStream.
	self adopt: stream.
	
	[ 1 to: 10 do: [ :each | stream nextPut: each ] ]
		atomic.
	self assert: (1 to: 10) asArray equals: stream contents! !

LRSTMTest subclass: #LRSTMCustomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMCustomTest methodsFor: 'actions' stamp: 'StefanMarr 7/18/2012 21:57'!
conflict
	<omniUnenforced>

	self transaction 
		addChange: (LRSTMCustomChange 
			onApply: [ value := true ]
			onConflictTest: [ true ])! !

!LRSTMCustomTest methodsFor: 'actions' stamp: 'StefanMarr 7/18/2012 22:08'!
sideeffect
	<omniUnenforced>

	self transaction 
		addChange: (LRSTMCustomChange onApply: [ value := true ])! !

!LRSTMCustomTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:22'!
testConflict
	self 
		should: [ [ self conflict ] atomic ]
		raise: LRSTMConflict.
	self assert: value isNil! !

!LRSTMCustomTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:23'!
testSideeffect
	[ self sideeffect ] atomic.
	self assert: value! !

LRSTMTest subclass: #LRSTMNestedTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Tests'!

!LRSTMNestedTest methodsFor: 'testing' stamp: 'StefanMarr 1/10/2012 11:45'!
expectedFailures
	^ #(testAbortInner) "STEFAN: 2012-01-10 did not work in the original 3.9 image built from Lukas repo either..."! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:46'!
testAbortInner
	self assert: [ value := true. [ value := false. self abort: value ] atomic. value ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:50'!
testAbortOuter
	self assert: [ [ value := true ] atomic. self abort: value ] atomic.
	self assert: value isNil! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:54'!
testEmpty
	[ [ ] atomic ] atomic! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:46'!
testKind
	self assert: [ self transaction ] atomic isNested not.
	self assert: [ [ self transaction ] atomic ] atomic isNested.
	self assert: [ [ [ self transaction ] atomic ] atomic ] atomic isNested.
	
	self assert: [ [ ] atomic. self transaction ] atomic isNested not.! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 16:54'!
testSimple
	[ [ value := true ] atomic ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:24'!
testValueInner
	self assert: [ value := true. [ value ] atomic ] atomic.
	self assert: value! !

!LRSTMNestedTest methodsFor: 'testing' stamp: 'lr 2/26/2008 18:24'!
testValueOuter
	self assert: [ [ value := true ] atomic. value ] atomic.
	self assert: value! !

!LRSTMTest class methodsFor: 'initialization' stamp: 'lr 5/4/2007 14:37'!
initialize
	self environment at: #GlobalValue put: nil! !

!LRSTMTest class methodsFor: 'testing' stamp: 'lr 2/26/2008 16:27'!
isAbstract
	^ self name = #LRSTMTest! !

!LRSTMTest methodsFor: 'utilities' stamp: 'StefanMarr 7/18/2012 21:55'!
abort: anObject
	<omniUnenforced>

	self transaction abort: anObject! !

!LRSTMTest methodsFor: 'utilities' stamp: 'StefanMarr 1/13/2013 17:47'!
adopt: obj
	Smalltalk at: #LRSTMDomain ifPresent: [:dom |
		^ dom domain adoptObject: obj].
	^ obj! !

!LRSTMTest methodsFor: 'utilities' stamp: 'StefanMarr 7/18/2012 21:56'!
checkpoint
	<omniUnenforced>

	self transaction checkpoint! !

!LRSTMTest methodsFor: 'running' stamp: 'StefanMarr 1/13/2013 17:48'!
setUp
	value := nil.
	array := OstArray new: 1.
	Value := nil.
	GlobalValue := nil.
	
	self adopt: self.
	self adopt: array.! !

!LRSTMTest methodsFor: 'running' stamp: 'StefanMarr 7/29/2012 00:11'!
tearDown
	Processor activeProcess currentTransaction: nil.
	^ super tearDown.! !

!LRSTMTest methodsFor: 'utilities' stamp: 'StefanMarr 7/18/2012 22:07'!
transaction
	<omniUnenforced>

	^ Processor activeProcess currentTransaction! !

!LRSTMTest methodsFor: 'accessing' stamp: 'lr 5/3/2007 15:59'!
value
	^ value! !

!LRSTMTest methodsFor: 'accessing' stamp: 'lr 6/8/2007 16:52'!
value: anObject
	value := anObject! !
LRSTMTest initialize!
